namespace RuleEngine.DTOs
{
    public class DeviceMessage
    {
        public string? Imei { get; set; }
        public string? ReceivedTime { get; set; }
        public double Longitude { get; set; }
        public double Latitude { get; set; }
        public int GpsSpeed { get; set; }
        public string? CelID { get; set; }
        public string? LacID { get; set; }
        public bool IsSOS { get; set; }
        public bool IsStrongBoxOpen { get; set; }
        public bool IsEngineOn { get; set; }
        public bool IsStopping { get; set; }
        public bool IsGPSLost { get; set; }
        public int TotalImgCam1 { get; set; }
        public int TotalImgCam2 { get; set; }
        public string? StrRFID { get; set; }
        public string? StrOBD { get; set; }
        public string? Provider { get; set; }
        public string? Version { get; set; }
        public int CpuTime { get; set; }
        public int GeoMinDistance { get; set; }
        public double NearestLat { get; set; }
        public double NearestLon { get; set; }
        public int NearestID { get; set; }
        public string? NearestName { get; set; }
        public int Maxsnr { get; set; }
        public string? CpuTemp { get; set; }
        public GpsInfor? GpsInfor { get; set; }
        public bool Cam1OK { get; set; }
        public bool Cam2OK { get; set; }
        public bool CamDetach { get; set; }
        public bool IsJamming { get; set; }
        public bool IsSpoofing { get; set; }
    }

    public class GpsInfor
    {
        public double AgcLevelDb { get; set; }
        public double Maxsnr { get; set; }
        public int SatelliteUseInFixed { get; set; }
        public string? Cellid { get; set; }
        public string? Lacid { get; set; }
        public string? Mcc { get; set; }
        public string? Mnc { get; set; }
        public string? NetworkType { get; set; }
        public string? SignalStrength { get; set; }
    }

}