﻿using Microsoft.EntityFrameworkCore;
using RuleEngine.Models;

namespace RuleEngine.Database
{
    public partial class DatabaseContext(DbContextOptions<DatabaseContext> options) : DbContext(options)
    {
        public virtual DbSet<AppVersion> AppVersion { get; set; }
        public virtual DbSet<Atmtechnican> Atmtechnicans { get; set; }
        public virtual DbSet<Car> Cars { get; set; }
        public virtual DbSet<DailyCar> DailyCars { get; set; }
        public virtual DbSet<DailyKmCar> DailyKmCars { get; set; }
        public virtual DbSet<Device> Devices { get; set; }
        public virtual DbSet<Driver> Drivers { get; set; }
        public virtual DbSet<Escort> Escorts { get; set; }
        public virtual DbSet<History> Histories { get; set; }
        public virtual DbSet<Online> Onlines { get; set; }
        public virtual DbSet<Permission> Permissions { get; set; }
        public virtual DbSet<Rfid> Rfids { get; set; }
        public virtual DbSet<Scope> Scopes { get; set; }
        public virtual DbSet<ScopePermission> ScopePermissions { get; set; }
        public virtual DbSet<TransactionPoint> TransactionPoints { get; set; }
        public virtual DbSet<Treasurer> Treasurers { get; set; }
        public virtual DbSet<Unit> Units { get; set; }
        public virtual DbSet<User> Users { get; set; }
        public virtual DbSet<UserUnit> UserUnits { get; set; }
        public virtual DbSet<Recipient> Recipients { get; set; }
        public virtual DbSet<RecipientWarnCfg> RecipientWarnCfgs { get; set; }
        public virtual DbSet<WarningEvent> WarningEvents { get; set; }
        public virtual DbSet<WarningType> WarningTypes { get; set; }
        public virtual DbSet<WarningSms> WarningSms { get; set; }
        public virtual DbSet<AppCfg> AppCfgs { get; set; }
        public virtual DbSet<Camera> Cameras { get; set; }
        public virtual DbSet<ReupLog> ReupLogs { get; set; }
        public virtual DbSet<CellInfor> CellInfors { get; set; }
        public virtual DbSet<Schedule> Schedules { get; set; }
        public virtual DbSet<Owner> Owners { get; set; }

        protected override void OnModelCreating(ModelBuilder modelBuilder)
        {
            modelBuilder.Entity<Schedule>(entity =>
            {
                entity.ToTable("Schedule");
            });

            modelBuilder.Entity<Owner>(entity =>
            {
                entity.ToTable("Owner");
            });

            modelBuilder.Entity<Device>(entity =>
            {
                entity.Property(e => e.ActivationTime).HasColumnType("date");

                entity.Property(e => e.AllowUpdate).HasDefaultValueSql("((1))");

                entity.Property(e => e.CarId).HasColumnName("CarId");

                entity.Property(e => e.DeviceNumber)

                    .HasMaxLength(50)
                    .IsUnicode(false);

                entity.Property(e => e.Imei)

                    .HasMaxLength(50)
                    .IsUnicode(false)
                    .HasColumnName("IMEI");

                entity.Property(e => e.Phone)

                    .HasMaxLength(15)
                    .IsUnicode(false);

                entity.Property(e => e.IsActive).HasDefaultValueSql("((1))");

                entity.Property(e => e.UnitId).HasColumnName("UnitId");
            });

            OnModelCreatingPartial(modelBuilder);
        }

        partial void OnModelCreatingPartial(ModelBuilder modelBuilder);
    }
}
